#include <avr/io.h>

.org 0x00 								; start address
vectors:
    rjmp   reset                        ; Reset Handler
    rjmp   vectors                      ; IRQ0 Handler
    rjmp   vectors                      ; PCINT0 Handler
    rjmp   vectors                      ; Timer0 Overflow Handler
    rjmp   vectors                      ; EEPROM Ready Handler
    rjmp   vectors                      ; Analog Comparator Handler
    rjmp   vectors                      ; Timer0 CompareA Handler
    rjmp   vectors                      ; Timer0 CompareB Handler
    rjmp   vectors                      ; Watchdog Interrupt Handler
    rjmp   vectors                      ; ADC Conversion Handler
reset:
    eor     r16,r16                     ; r=0;
    out     _SFR_IO_ADDR(SREG),r16      ; clean Status Register
    ldi     r16, RAMEND                 ; r16=0x9f
    out     _SFR_IO_ADDR(SPL),r16       ; Set Stack Pointer to top of RAM
main:
	sbi     _SFR_IO_ADDR(DDRB), PB0		; DDRB|=(1<<PB0)
	ldi     r25, _BV(PB0)				; r25=1
loop:									; main loop
	in      r24, _SFR_IO_ADDR(PORTB)	; r24=PORTB
	eor     r24, r25					; r24 = r24 xor r25
	out     _SFR_IO_ADDR(PORTB), r24	; PORTB=r25
	ldi     r18, 0x3F					; r18=0x3F
	ldi     r19, 0x0D					; r19=0x0D
	ldi     r24, 0x03					; r24=0x03
delay:
	subi    r18, 0x01					; (r18r19r24)-1  вычитание трехбайтного целого числа
	sbci    r19, 0x00
	sbci    r24, 0x00
	brne    delay						; если значение в r24 не равно нулю, то переход на начало операции вычитания
	rjmp    loop						; возврат на начало главного цикла
