#include <avr/io.h>
#include <avr/pgmspace.h>
#include "led.h"

uint8_t reg=0;

const unsigned char digit[10] PROGMEM = {
      0b11000000, // 0
      0b11111001, // 1
      0b10100100, // 2
      0b10110000, // 3
      0b10011001, // 4
      0b10010010, // 5
      0b10000010, // 6
      0b11111000, // 7
      0b10000000, // 8
      0b10010000, // 9
};

void spi_transmit(uint8_t data) {
    uint8_t i;
    for (i=0; i<8; i++)
    {
        PORTB=(data & 0x80) ? PORTB | DIO : PORTB & ~DIO;

        data=(data<<1);
        PORTB |= SCLK;
        PORTB &= ~SCLK;
    }
}

void to_led(uint8_t value, uint8_t reg) {
	if (value <10 && reg < 4) {
		char * ptr= (char *)(&digit);
        PORTB &= ~RCLK;
        spi_transmit(pgm_read_byte(ptr+value));
        spi_transmit(1<<reg);
        PORTB |= RCLK;
	}
}

void show_led(uint16_t num) {
	switch (reg) {
	case 0:
		to_led((uint8_t)(num%10),0);
		break;
	case 1:
		if (num>=10)
			to_led((uint8_t)((num%100)/10),1);
		break;
	case 2:
		if (num>=100)
			to_led((uint8_t)(num/100),2);
		break;
	}
	reg = (reg ==  2) ? 0 : reg+1;
}
